{% extends "front/base_logged.html" %}
{% load i18n %}
{% load static %}
{% load render_table from django_tables2 %}

{% block content %}

    {% include "wizard/header.html" %}

    {% if flag %}

    <div class="panel panel-default">
        <div class="panel-heading">
            <strong>{% trans "Definir fontes para Qualidade de Água" %}</strong>
            <div class="help">
                <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                    <span class="glyphicon glyphicon-question-sign"></span>
                </button>
                <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                    <span class="glyphicon glyphicon-info-sign"></span>
                </button>
            </div>
        </div>
        <div id="help" class="alert alert-warning cst_hide">
            {% include "wizard/help_text/step_wsources.html" %}
        </div>
        <div class="panel-body">
            {% blocktrans trimmed %}
            Caso o utilizador tenha escolhido adicionar fontes adicionais para qualidade de água, deve definir as condições de forçamento para todas as fontes que adicionar. 
            {% endblocktrans %}
        </div>
      </div>

    {% endif %}

    {% if forcings_table %}
    <div class="panel panel-default">
        <div class="panel-heading">
            <strong>{% trans "Definir condições para Qualidade de Água" %}</strong>
            <div class="help">
                <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                    <span class="glyphicon glyphicon-question-sign"></span>
                </button>
                <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                    <span class="glyphicon glyphicon-info-sign"></span>
                </button>
            </div>
        </div>
        <div id="help" class="alert alert-warning cst_hide">
           {% include "wizard/help_text/step_wquality.html" %}
        </div>
        <div class="panel-body">
            {% blocktrans trimmed %}
            Caso o utilizador tenha escolhido uma simulação envolvendo qualidade de água, deve definir as condições de forçamento das variáveis de qualidade da água nas fronteiras oceânicas e fluviais. 
            O utilizador pode também definir outras fontes adicionais. 
            {% endblocktrans %}
        </div>
    </div>
    {% endif %}

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    {% if forcings_table %}
    <div class="row nopad">
        <h5><strong>{% trans 'Selecione uma ou mais fronteiras para a qualidade da água' %}</strong></h5>
    </div>

    <div class="row nopad resizableCols">
        <div class="col1">
            {% render_table forcings_table %}
            <button id="btn_define" class="btn btn-primary btn-sm"><strong>{% trans "Definir condições para qualidade de água" %}</strong></button>
        </div>
        <div class="col2">
            {% include "wizard/map.html" %}
        </div>
    </div>
    {% endif %}

    {% if flag %}
    <div class="row nopad">
        <h5><strong>{% trans 'Marque/desmarque as fontes que pretende usar. Pode adicionar novas fontes marcando uma localização no mapa ou com o botão Nova Fonte.' %}</strong>
            <br/>{% trans 'Nota: se a lista estiver vazia à partida isso significa que não existem pontos de fontes localizados dentro do domínio da malha.' %}
        </h5>
    </div>

    <div class="row nopad resizableCols">
        <div class="col1">
            {% if sources_table %}
            {% render_table sources_table %}
            {% endif %}

            <button id="btn_define" class="btn btn-primary btn-sm"><strong>{% trans "Nova Fonte" %}</strong></button>
        </div>
        <div class="col2">
            {% include "wizard/map.html" %}
        </div>
    </div>

    <form id="source_form" class="form" method="post">{% csrf_token %}
        {% include "wizard/modal/sourcenew.html" %}

        <div class="forms">
            <div class="row btnmenu">
                <div class="col-xs-6">
                    <button id="btn_prev" type="button" class="btn btn-default" data-step="12" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                        <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                    </button>
                    <button id="btn_restart" class="btn btn-default" data-step="11" data-intro="{% trans 'ou limpe e recomeçe o passo' %}" data-toggle="tooltip" data-placement="top" title="{% trans 'Reset do passo e apaga passos posteriores' %}">{% trans "Recomeçar passo" %}</button>
                </div>
                {% if not flag_continue %}
                <div class="col-xs-6 text-right">
                    <button id="btn_submit" type="submit" name="next" class="btn btn-primary" data-step="10" data-intro="{% trans 'Prima o botão' %}">
                        {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                    </button>
                </div>
                {% else %}
                <div class="col-xs-6 text-right">
                    <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="{% trans 'Aplicar alterações efetuadas ao passo' %}" data-step="10" data-intro="{% trans 'Se efetuar alterações ao passo prima este botão para as guardar' %}">
                        {% trans "Guardar alterações" %}
                    </button>
                    <button id="btn_next" class="btn btn-default" data-step="13" data-intro="{% trans 'Ou passos posteriores' %}">
                        {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                    </button>
                </div>
                {% endif %}
            </div>
        </div>
    </form>
    {% endif %}

    {% if forcings_table %}
    <form class="form" method="post">{% csrf_token %}
        {% include "wizard/modal/wqchoice.html" %}

        {% for field in forms.0 %}
            {% if not 'hidden' in field %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endif %}
        {% endfor %}

        <div class="forms">
            <div class="row btnmenu">
                <div class="col-xs-6">
                    <button id="btn_prev" type="button" class="btn btn-default" data-step="12" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                        <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                    </button>
                    <button id="btn_restart" class="btn btn-default" data-step="11" data-intro="{% trans 'ou limpe e recomeçe o passo' %}" data-toggle="tooltip" data-placement="top" title="{% trans 'Reset do passo e apaga passos posteriores' %}">{% trans "Recomeçar passo" %}</button>
                </div>
                {% if not flag_continue %}
                <div class="col-xs-6 text-right">
                    <button id="btn_submit" type="submit" name="next" class="btn btn-primary" data-step="10" data-intro="{% trans 'Prima o botão' %}">
                        {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                    </button>
                </div>
                {% else %}
                <div class="col-xs-6 text-right">
                    <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="{% trans 'Aplicar alterações efetuadas ao passo' %}" data-step="10" data-intro="{% trans 'Se efetuar alterações ao passo prima este botão para as guardar' %}">
                        {% trans "Guardar alterações" %}
                    </button>
                    <button id="btn_next" class="btn btn-default" data-step="13" data-intro="{% trans 'Ou passos posteriores' %}">
                        {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                    </button>
                </div>
                {% endif %}
            </div>
    </form>
    {% endif %}

    <!-- Load some extra resources -->
    <!-- JQuery UI - IMPORTANT - custom build without tooltip widget (conflict with Bootstrap) -->
    <link rel="stylesheet" href="{% static 'vendor/jquery/jquery-ui-1.12.1.min.css' %}">
    <script src="{% static 'vendor/jquery/jquery-ui-1.12.1.min.js' %}"></script>

    <script type="text/javascript">

        {% if flag %}

        var max_sources = {{ max_sources|default:5 }};    // max number of allowed checked stations
        var rec_distance = {{ rec_distance|default:100 }};  // recommended distance between comparision stations

        $('#btn_apply').click(function(e){
            e.preventDefault();

            // Clear errors
            $("#form_errors").hide();
            $('#form_errors').html('');

            var flag = true;
            var msg = '{% trans "Para continuar terá de preencher os campos obrigatórios (*)." %}';
            var msg1 = '{% trans "Terá de preencher o(s) campo(s) da opção selecionada para as fontes." %}';
            var msg2 = '{% trans "Para continuar terá de corrigir os campos inválidos." %}';

            if (name == '' || Number.isNaN(lat) || Number.isNaN(lon) ) {
                flag = false;
                $('#form_errors').html(msg);
                $("#form_errors").show();
            }

            if (flag){

                var name = $("input[name='name']").val();
                var lat = parseFloat($("input[name='lat']").val());
                var lon = parseFloat($("input[name='lon']").val());

                var months = ['{% trans "Jan" %}', '{% trans "Fev" %}', '{% trans "Mar" %}', '{% trans "Abr" %}', '{% trans "Mai" %}',
                '{% trans "Jun" %}', '{% trans "Jul" %}', '{% trans "Ago" %}', '{% trans "Set" %}', '{% trans "Out" %}',
                '{% trans "Nov" %}', '{% trans "Dez" %}'];

                var fmodel_text = [];

                // Show error
                // Add some animation
                var btn = $(this);
                var btnlbl = btn.html().replace('<span class="glyphicon glyphicon-repeat spin"></span> ', '');
                btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

                // Disable buttons to prevent multiple calls
                btn.attr('disabled', '');
                btn.prev().attr('disabled', '');

                // Set some timeout to allow changes to buttons above to render
                setTimeout( function() {
                    // Validate if coordinates inside BBox polygon
                    var point = new L.LatLng(lat, lon);
                    var pointIN = insideBBox(point);

                    // Reset form
                    btn.html(btnlbl);
                    btn.removeAttr('disabled');
                    btn.prev().removeAttr('disabled');

                    if(flag){
                    var vals_flux = [];
                        var flux_input = $("input[name='flux_input']:checked").val();
                        if (flux_input == 'annual') {
                            var field = $('#id_flux13');
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("flux");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_flux.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (flux_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_flux' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("flux");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_flux.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_flux = "[" + vals_flux.join(", ") + "]";
                        }
                        else if (flux_input == 'url') {
                            var field = $('#id_url');
                            if (field.val().indexOf("http://") == -1) {
                                msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                                flag = false;
                            } else {
                                vals_flux.push(field.val());
                            }
                        }
                        fmodel_text.push("{% trans "Fluxo" %}: " + vals_flux.toString());
                    }

                    {% if "3d" in baroclinic_type %}
                    if(flag){
                        var vals_temp = [];
                        var temp_input = $("input[name='temp_input']:checked").val();
                        if (temp_input == 'annual') {
                            var field = $('#id_temp13');
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("temp");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_temp.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (temp_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_temp' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("temp");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_temp.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_temp = "[" + vals_temp.join(", ") + "]";
                        }
                        else if (temp_input == 'url') {
                            var field = $('#id_url');
                            if (field.val().indexOf("http://") == -1) {
                                msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                                flag = false;
                            } else {
                                vals_temp.push(field.val());
                            }
                        }
                        fmodel_text.push("{% trans "Temperatura" %}: " + vals_temp.toString());
                    }

                    if(flag){
                        var vals_salt = [];
                        var salt_input = $("input[name='salt_input']:checked").val();
                        if (salt_input == 'annual') {
                            var field = $('#id_salt13');
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("salt");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_salt.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (salt_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_salt' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("salt");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_salt.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_salt = "[" + vals_salt.join(", ") + "]";
                        }
                        else if (salt_input == 'url') {
                            var field = $('#id_url');
                            if (field.val().indexOf("http://") == -1) {
                                msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                                flag = false;
                            } else {
                                vals_salt.push(field.val());
                            }
                        }
                        fmodel_text.push("{% trans "Salinidade" %}: " + vals_salt.toString());
                    }
                    {% endif %}

                    {% if "fecal" in wq_type %}
                    if(flag){
                        var vals_ecoli = [];
                        var ecoli_input = $("input[name='ecoli_input']:checked").val();
                        if (ecoli_input == 'annual') {
                            var field = $('#id_ecoli13');
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("ecoli");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_ecoli.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (ecoli_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_ecoli' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("ecoli");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_ecoli.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_ecoli = "[" + vals_ecoli.join(", ") + "]";
                        }
                        else if (ecoli_input == 'url') {
                            var field = $('#id_url');
                            if (field.val().indexOf("http://") == -1) {
                                msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                                flag = false;
                            } else {
                                vals_ecoli.push(field.val());
                            }
                        }
                        fmodel_text.push("{% trans "E-coli" %}: " + vals_ecoli.toString());
                    }

                    if(flag){
                        var vals_enterococcus = [];
                        var enterococcus_input = $("input[name='enterococcus_input']:checked").val();

                        if (enterococcus_input == 'annual') {
                            // Annual option was selected
                            var field = $('#id_enterococcus13');
                            // Check if value exists and is valid
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("enterococcus");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_enterococcus.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (enterococcus_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_enterococcus' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("enterococcus");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_enterococcus.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_enterococcus = "[" + vals_enterococcus.join(", ") + "]";
                        }
                        else if (enterococcus_input == 'url') {
                            var field = $('#id_url');
                            if (field.val().indexOf("http://") == -1) {
                                msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                                flag = false;
                            } else {
                                vals_enterococcus.push(field.val());
                            }
                        }
                        fmodel_text.push("{% trans "Enterococcus" %}: " + vals_enterococcus.toString());
                    }
                    {% endif %}

                    {% if "generic" in wq_type %}
                    if(flag){
                        var vals_generic = [];
                        var generic_input = $("input[name='generic_input']:checked").val();
                        if (generic_input == 'annual') {
                            var field = $('#id_generic13');
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("generic");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_generic.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (generic_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_generic' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("generic");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_generic.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_generic = "[" + vals_generic.join(", ") + "]";
                        }
                        else if (generic_input == 'url') {
                            var field = $('#id_url');
                            if (field.val().indexOf("http://") == -1) {
                                msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                                flag = false;
                            } else {
                                vals_generic.push(field.val());
                            }
                        }
                        fmodel_text.push("{% trans "Traçador Genérico" %}: " + vals_generic.toString());
                    }
                    {% endif %}

                    if (!pointIN) {
                        var msg = '{% trans "A nova fonte tem de estar posicionada dentro da malha!" %}';
                        $('#form_errors').html(msg);
                        $("#form_errors").show();
                    } 
                    else if (!flag) {
                        $('#form_errors').html(msg);
                        $("#form_errors").show();
                    }
                    else {
                        // Validate if coordinate already exists in table and if not too close to others
                        var pointOK = validPoint($("#sid").val(), lat, lon);
                        if (pointOK > 0) {
                            if (pointOK == 1) {
                                var msg = '{% trans "Já existe uma fonte nova nessa coordenada!" %}';
                            } else {
                                var msg = '{% trans "Já existe uma fonte nova demasiado próxima dessa coordenada!" %}';
                            }

                            $('#form_errors').html(msg);
                            $("#form_errors").show();
                        } else {
                            // All is good - set station
                            setSource(name, lat, lon, fmodel_text);
                            // Reset form
                            $('#source_form')[0].reset();
                            // Hide modal form
                            $('#divModal_forcing').modal('hide');
                        }
                    }
                }, 10);
            }
        });
        
        function activateTab(tab) {
            // if link enabled show tab
            if (!$('.nav-pills a[href="#' + tab + '"]').hasClass("disabled")) {
                $('.nav-pills a[href="#' + tab + '"]').tab('show');
            }
        }

        // Hover Source table row - highlight feature
        $('#sources_table tbody tr').hover(function(e) {
            setHighlight(e);
          }, function(e) {
            resetHighlight(e);
          }
        );

        // Click Sources table row
        $('#sources_table tbody tr').click(function(e) {
            rowClick(e.currentTarget, name);
        });

        // Prettify long JSON
        function prettify(json) {
            var out = "";
            for (var i = 0; i < json.length; ++i) {
                var obj = JSON.stringify(json[i], null, ' ');
                if (i == json.length - 1) {
                    out += obj.replace(/"/g, "").replace("{", "").replace("}", "");
                } else {
                    out += obj.replace(/"/g, "").replace("{", "").replace("}", "") + '<br>';
                }
            }
            return out;
        }

                // DePrettify long JSON
        function deprettify(string) {
            var out = {};
            var fmodeltype = "string";

            var arr = string.split('\n');
            for (var i = 0; i < arr.length; ++i) {
                if (arr[i].indexOf(':') > -1) {
                    // multiple objects
                    var obj = arr[i].split(":")[0];
                    var val = arr[i].substring(obj.length+1, arr[i].length); // Get the rest of the string
                } else {
                    // if single object then its flow
                    var obj = "flow";
                    var val = arr[i];
                }
                    if (val.indexOf('[') >= 0) {
                        // Monthly
                        var sarray = val.replace("[", "").replace("]", "").split(', ');
                        var oarray = [];
                        for (var j=0; j<sarray.length; j++) {
                            oarray.push(parseFloat(sarray[j].split(":")[1]));
                        }
                        out[obj] = {'type': 'monthly', 'value': oarray};
                    }
                    else if (val.indexOf('=') >= 0) {
                        // Annual
                        out[obj] = {'type': 'annual', 'value': parseFloat(val.split("=")[1])};
                    }
                    else if (val.indexOf('http') >= 0) {
                        // Url
                        out[obj] = {'type': 'url', 'value': val};
                    }

            }

            console.log(out);
            return out;
        }

        function rowClick(row) {
            // Zoom to map feature
            var lat = row.cells[2].innerText;
            var lon = row.cells[3].innerText;
            // set the view
            map.setView([lat, lon], 16);
        }

        function setHighlight(e) {
            var sid = e.currentTarget.cells[0].children[0].getAttribute('data-code');
            var layer = map._layers[sid];
            if (layer) {
                layer.setStyle({
                  weight: 4,
                });
            }
        }

        function resetHighlight(e) {
            var sid = e.currentTarget.cells[0].children[0].getAttribute('data-code');
            var layer = map._layers[sid];
            if (layer) {
              layer.setStyle({
                weight: 2,
              });
            }
        }

        function sourcesMaxLimit() {
            // Max stations reached?
            var selsources = $('.selSID:checked');
            if (selsources.length >= max_sources) {
                return true;
            }
            return false;
        }

        function getDistance(origin, destination) {
            // return distance in meters
            var lon1 = toRadian(origin[1]),
                lat1 = toRadian(origin[0]),
                lon2 = toRadian(destination[1]),
                lat2 = toRadian(destination[0]);

            var deltaLat = lat2 - lat1;
            var deltaLon = lon2 - lon1;

            var a = Math.pow(Math.sin(deltaLat/2), 2) + Math.cos(lat1) * Math.cos(lat2) * Math.pow(Math.sin(deltaLon/2), 2);
            var c = 2 * Math.asin(Math.sqrt(a));
            var EARTH_RADIUS = 6371;
            return Math.round(c * EARTH_RADIUS * 1000);
        }

        function toRadian(degree) {
            // Degree to radian
            return degree*Math.PI/180;
        }

        $('#btn_define').click(function(e){
            if (!sourcesMaxLimit()) {
                // Change Form's Title
                $('#formLabel').html('{% trans "Nova Fonte" %}');
                $('#applyLabel').html('{% trans "Adicionar" %}');
                $("#sid").val(null);

                // Reset form before opening modal form
                clearForm();

                $('#divModal_forcing').modal('show');
            } else {
                $('#msg_str').html('{% trans "Atingiu o limite máximo de fontes que pode usar num modelo " %} ('+ max_sources + ').');
                $('#divModal_msg').modal('show');
            }
        });
        
        function clearForm() {
            // Clear form
            $('#source_form')[0].reset();
            toggleFields();
            // Clear input notes
            $('#source_form h5').html('');
        }

        // Toggle Comparison Form fields
        function toggleFields() {
            $("#form_errors").hide();
            $('#form_errors').html('');
        }

        // Enable / disable comparision inputs
        function disable_comparision_inputs(disable) {
            $(".grp_C").each(function(){
                if (disable) {
                    $(this).attr('disabled', 'disabled');
                } else {
                    $(this).removeAttr('disabled');
                }
            });
        }

        function toggleMarkers(e) {
            var selsources = $('.selSID:checked');
            if (e.checked) {
                //if (selstations.length <= max_stations || stype == 'C') { // allow all comparision stations
                // Check only if station's max limit not reached
                if (selsources.length <= max_sources) {
                    // Hide/unhide marker
                    var layer_id = e.getAttribute('data-code');
                    var layer = map._layers[layer_id];
                    if (e.checked) {
                        layer.options.dashArray = null;
                    } else {
                        layer.options.dashArray = '5,5';
                    }
                    // pointsGroup.refreshClusters(); // markers cluster not in use
                } else {
                    e.checked = false;
                    $('#msg_str').html('{% trans "Atingiu o limite máximo de fontes que pode usar num modelo " %} ('+ max_sources + ').');
                    $('#divModal_msg').modal('show');
                }
            } else {
                var layer_id = e.getAttribute('data-code');
                var layer = map._layers[layer_id];
                layer.options.dashArray = '5,5';
            }
        }


        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true, errors = [], error_str = '';
            var msg = '{% trans "Para continuar terá de:" %}' + '<br/>';
            try {
                // Build chosen stations array
                var sources = [];
                $('#sources_table tbody tr').each(function(i, obj){
                    var sid = obj.cells[0].children[0].getAttribute('data-code');
                    var chk = obj.cells[0].children[0];
                    var name = obj.cells[1].innerText;
                    var lat = obj.cells[2].innerText;
                    var lon = obj.cells[3].innerText;
                    var fmodel = obj.cells[4].innerText;


                    if(fmodel == ''){
                        flagok = false;
                        {% if "3d" in baroclinic_type %}
                        error_str = '{% trans "- selecionar forçamentos de Temperatura e Salinidade a aplicar a todas as fronteiras oceânicas na tabela." %}';
                        {% endif %}
                        {% if "fecal" in wq_type %}
                            error_str = '{% trans "- selecionar forçamentos de E-coli e Enterococcus a aplicar a todas as fronteiras na tabela." %}';
                        {% endif %}
                        {% if "generic" in wq_type %}
                            error_str = '{% trans "- selecionar forçamentos de Traçador Genérico a aplicar a todas as fronteiras na tabela." %}';
                        {% endif %}
                        if (errors.indexOf(error_str) === -1) errors.push(error_str);
                    }

                    // DePrettify long JSON
                    fmodel = deprettify(fmodel);

                    // for each row build deploy station dict
                    var chk_val = (chk.checked) ? 1 : 0;
                    var sdict = {'chk': chk_val, 'code': sid, 'name': name, 'lat': lat, 'lon': lon, 'fmodel': fmodel};

                    sources.push(sdict);
                });

                if(sources.length == 0){
                    flagok = false;
                    error_str = '{% trans "- adicionar uma (ou várias) fontes ao sistema de previsão." %}'
                    if (errors.indexOf(error_str) === -1) errors.push(error_str);
                }

                if (!flagok) {
                    $('#msg_str').html(msg + errors.join('<br/>'));
                    $('#divModal_msg').modal('show');
                    return false;
                }

                $('#divModal_processing').modal('show');

                $.ajaxSetup({beforeSend: function(xhr, settings){
                    xhr.setRequestHeader('X-CSRFToken', '{{ csrf_token }}');
                }});

                $('#id_sources').val(JSON.stringify(sources));

                var btnname = e.currentTarget.name;
                if (btnname == 'edit') {
                    e.preventDefault();
                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: {
                            'getsourcesdata': JSON.stringify(sources),
                        },
                        dataType: 'json',
                        success: function(data) {
                            $('#divModal_processing').modal('hide');

                            if (data['msg']) {
                                $('#msg_str').html(data['msg']);
                                $('#divModal_msg').modal('show');
                            }
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });
                }
                else{
                    e.preventDefault();
                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: {
                            'getsourcesdata': JSON.stringify(sources),
                        },
                        dataType: 'json',
                        success: function(data) {
                            window.location.href = '/wizard/step8';
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });

                }
            } catch(err) {
                e.preventDefault();
                console.log(err);
                $('#divModal_processing').modal('hide');

                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });

        var sortStations = function (select, lat, lon) {
            // Sort stations by distance to point ASC
            $(select).html($(select).children('option').sort(function (a, b) {
                var csource1 = a.text;
                var csource2 = b.text;

                if (cstation1 == '-----') return -1;

                var clat1 = parseFloat(cstation1.substring(cstation1.indexOf('(')+1, cstation1.indexOf(',')));
                var clon1 = parseFloat(cstation1.substring(cstation1.indexOf(',')+2, cstation1.indexOf(')')));

                var clat2 = parseFloat(cstation2.substring(cstation2.indexOf('(')+1, cstation2.indexOf(',')));
                var clon2 = parseFloat(cstation2.substring(cstation2.indexOf(',')+2, cstation2.indexOf(')')));

                var distance1 = getDistance([lat, lon], [clat1, clon1]);
                var distance2 = getDistance([lat, lon], [clat2, clon2]);

                return distance1 < distance2 ? -1 : 1;
            }));
            $(select).get(0).selectedIndex = 0;
        };

        var sortSelect = function (select) {
            // Sort select alphabetically ASC
            $(select).html($(select).children('option').sort(function (x, y) {
                return $(x).text().toUpperCase() < $(y).text().toUpperCase() ? -1 : 1;
            }));
            $(select).get(0).selectedIndex = 0;
        };

        function validPoint(id, lat, lon) {
            // Validate new station's coordinates - can't exist already in table or be too close
            var error = 0, precision = 3;
            $('#sources_table tbody tr').each(function(i, currow) {
                var sid = currow.cells[0].children[0].getAttribute('data-code');
                var cur_lat = parseFloat(currow.cells[2].innerText);
                var cur_lon = parseFloat(currow.cells[3].innerText);
                if (id != sid) {
                    // Same coordinate position or too close?
                    if (cur_lat == lat && cur_lon == lon) {
                        error = 1;
                        return;
                    } else if (cur_lat.toFixed(precision) == lat.toFixed(precision) && cur_lon.toFixed(precision) == lon.toFixed(precision)) {
                        error = 2;
                        return;
                    }
                }
            });
            return error;
        }

        function addStation(layer_id) {
            var feature = map._layers[layer_id].feature;
            var name = feature.properties.name;
            var lat = feature.geometry.coordinates[1];
            var lon = feature.geometry.coordinates[0];
            var fmodel = feature.properties.forcings;
            // Clear sid - new point
            $("#sid").val(null);

            // Add station
            setSource(name, lat, lon, fmodel);
        }

        function removeStation(layer_id) {
            // Remove corresponding line in table
            $('[data-code=' + layer_id + ']').parent().parent().remove();
            var layer = pointsGroup.getLayer(layer_id);   // map._layers[layer_id]; (method used if marker cluster)
            // Remove point in map
            pointsGroup.removeLayer(layer);
            // Remove connecting line if exists
            var connectline = linesGroup.getLayer(layer_id.replace('C', 'L'));
            if (connectline) linesGroup.removeLayer(connectline);
        }

        function setSource(name, lat, lon, fmodel) {
            // Default circle settings
            var fillColor = '#a76bcf', rad = 2, fillOpacity = 0.8, border = 2, dashArray = null;

            // Increase comparision station radius to overlay observation station
            rad = 10;

            var layer_id = $("#sid").val();
            if (layer_id) {
                var selrow = null;
                // Edit row cell
                $('#sources_table tbody tr').each(function(i, currow) {
                    var chk = currow.cells[0].children[0];
                    var row_sid = chk.getAttribute('data-code');
                    if (!chk.checked) dashArray = '5,5';  // checkbox is not selected so render dashed point if created
                    if (layer_id == row_sid) {
                        currow.cells[1].innerText = name;
                        currow.cells[2].innerText = parseFloat(lat);
                        currow.cells[3].innerText = parseFloat(lon);
                        currow.cells[4].innerText = prettify(fmodel);
                        selrow = currow;
                        return;
                    }
                });

                // Get layer being edited
                var layer = map._layers[layer_id];
                if (layer) {
                    // Build popup window content
                    var popupCtn = buildPopupSource(layer_id, name);

                    // Update popup content
                    layer._popup.setContent(popupCtn);

                    // Update station name
                    layer.feature.properties.name = name;

                    // If no changes in coordinates - no need to continue
                    if (layer._latlng.lat == lat && layer._latlng.lng == lon) return;

                    // If coordinates changed remove station from cluster and add new one
                    pointsGroup.removeLayer(layer);
                } else {
                    return;
                }
            }

            // Add point to map
            var point = new L.LatLng(lat, lon);
            var pointMarkerOptions = {radius: rad, fillColor: fillColor, color: "#333", weight: border, opacity: fillOpacity, fillOpacity: fillOpacity, dashArray: dashArray, riseOnHover: true};
            var pointMarker = L.circleMarker(point, pointMarkerOptions);

            // Generate unique id for layer (if comparision station save in new_id the observation station id)
            var layers = map._layers;
            var counter = 1;

            var test_id = 'Source' + '_' + counter;
            // Loop until new leaflet layer id is found
            while (layers[test_id] != undefined) {
                counter += 1;
                var test_id = 'SOURCE' + '_' + counter;
            }
            var new_sid = test_id;

            pointMarker._leaflet_id = new_sid;
            pointMarker.properties = { 'name': name };

            // Build popup window content
            var popupCtn = buildPopupSource(new_sid, name);

            pointMarker.bindPopup(popupCtn);
            pointMarker.on({
              mouseover: highlightStation,
              mouseout: resetStation,
            });

            pointsGroup.addLayer(pointMarker);

            if (layer_id) {
                selrow.cells[0].children[0].setAttribute('data-code', new_sid);
            } else {
                // Add row to table
                var strcnt = '<td class="chk"><input class="selSID" type="checkbox" data-code="' + new_sid + '"checked onclick="event.stopPropagation();" onchange="toggleMarkers(this);" /></td>';
                strcnt += '<td class="name">' + name + '</td>';
                strcnt += '<td class="lat">' + parseFloat(lat) + '</td>';
                strcnt += '<td class="lon">' + parseFloat(lon) + '</td>';
                strcnt += '<td class="fmodel">' + prettify(fmodel) + '</td>';

                var row = $('<tr class="odd" onclick="rowClick(this);"></tr>');
                row.html(strcnt);
                row.hover(function(e) {
                    setHighlight(e);
                  }, function(e) {
                    resetHighlight(e);
                  }
                );

                $('#sources_table > tbody').append(row);
                map.closePopup();
            }
        }

        // Tooltips Setup (for Intro.js)
        $('#sources_table').attr("data-step", 5);
        $('#sources_table').attr("data-intro", "{% trans 'As fontes selecionadas na lista serão usadas para []' %}");

        $('.col2').attr("data-step", 6);
        $('.col2').attr("data-intro", "{% trans 'Pode adicionar novas fontes localizadas dentro da malha clickando a sua posição no mapa e preenchendo o formulário' %}");

        $('#btn_define').attr("data-step", 7);
        $('#btn_define').attr("data-intro", "{% trans 'Ou premindo o botão Nova Fonte e preenchendo o formulário' %}");

        $('#map').attr("data-step", 8);
        $('#map').attr("data-intro", "{% trans 'Pode remover fontes da lista premindo sobre elas no mapa e no botão Remover' %}");

        $(function(){
            // Hide error panel
            $('#form_errors').hide();

            // Set Table as resizable
            $(".resizableCols .col1").resizable({
                handles: 'e',
                minWidth: 300,
                maxWidth: 600,
                resize: function() {
                  $('.col1').css('width', $('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth() + '%');
                  $('.col2').css('width', 100 - ($('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth()) + '%');
                  map.invalidateSize(false);
                }
            });
        });

        {% endif %}

        {% if forcings_table %}
            // Hover Forcing table row - highlight layer
            $('#forcings_table tbody tr').hover(function(e) {
            var bid = e.currentTarget.cells[1].innerText;
            var layer = boundariesLayer.getLayer(bid);
            if (layer) {
                layer.setStyle({
                  weight: 9,
                  opacity: 0.6,
                });
            }
            // Also update Map's Info Panel
            info.update(bid, 'B');
          }, function(e) {
            var bid = e.currentTarget.cells[1].innerText;
            var layer = boundariesLayer.getLayer(bid);
            if (layer) {
              layer.setStyle({
                weight: 4,
                opacity: 1,
              });
            }
            // Clear Map's Info Panel
            info.update();
          }
        );

        // Button Show Forcing modal form
        $('#btn_define').click(function(e){
            var selectedbid = [];
            var selbids = $('.selBID:checked');
            if (selbids.length == 0) {
                $('#msg_str').html('{% trans "Selecione uma ou mais fronteiras para definir condições para qualidade de água." %}');
                $('#divModal_msg').modal('show');
                return;
            } else {
                selbids.each(function(i, obj){
                    selectedbid.push($(obj).attr('data-bid'));
                });
            }

            // Clear forcings form
            clear_forcings_form();

            // Change Form's labels
            var lbl = selectedbid.join();
            $('#bidLabel').html(lbl);
            $('#applyLabel').html("{% trans 'Definir' %}");

            // Disable from bids select the bids user has selected
            $('#id_bids option').each(function() {
                var val = $(this).val();
                if (val != "" && lbl.indexOf(val) > -1) {
                    $(this).attr('disabled', 'disabled');
                }
            });

            // Show modal form
            $('#divModal_forcing').modal('show');
        });

        // Clear forcings form
        function clear_forcings_form() {
            // Clear errors
            $("#form_errors").hide();
            $('#form_errors').html('');

            // Clear river inputs
            for (var index = 1; index <= 13; ++index) {
                {% if "fecal" in wq_type %}
                    $('#id_ecoli' + index).val('');
                    $('#id_enterococcus' + index).val('');
                {% endif %}
                {% if "generic" in wq_type %}
                    $('#id_generic' + index).val('');
                {% endif %}
            }
            $('#id_url').val('');
            $('#id_bid_perc').val('');
            // Clear and enable bids options
            $('#id_bids option').each(function() {
                $(this).removeAttr('disabled');
            });
            $('#id_bids option:selected').prop('selected', false);
            {% if "fecal" in wq_type %}
                $("input[name='ecoli'][value='annual']").prop('checked', true);
                $("input[name='enterococcus_input'][value='annual']").prop('checked', true);
            {% endif %}
        }

        // Toggle select/unselect row checkbox on table row click
        /* if not in use - row click now opens filled forcing form */
        $('#forcings_table tr').click(function(e){
            var chk = $(this).find('input:checkbox')[0];
            toggleBID(chk, 'row');
        });

        $('.selBID').click(function(e){
            toggleBID(this, '');
        });

        // Toggle BID selection
        function toggleBID(chk, ev) {
            // Toggle checked state if click fired from row
            if (ev == 'row') chk.checked = !chk.checked;

            var bid = $(chk).attr('data-bid');
            if (chk.checked) {
                // Change layer's style on map
                var layer = boundariesLayer.getLayer(bid);
                if (layer) {
                    layer.setStyle({
                      color: "black",
                      dashArray: '30 10',
                    });
                }
            } else {
                var layer = boundariesLayer.getLayer(bid);
                if (layer) boundariesLayer.resetStyle(layer);
            }
        }

        function activateTab(tab) {
            // if link enabled show tab
            if (!$('.nav-pills a[href="#' + tab + '"]').hasClass("disabled")) {
                $('.nav-pills a[href="#' + tab + '"]').tab('show');
            }
        }

        $('#btn_apply').click(function(e){
            e.preventDefault();

            // Clear errors
            $("#form_errors").hide();
            $('#form_errors').html('');

            var flag = true;
            var months = ['{% trans "Jan" %}', '{% trans "Fev" %}', '{% trans "Mar" %}', '{% trans "Abr" %}', '{% trans "Mai" %}',
            '{% trans "Jun" %}', '{% trans "Jul" %}', '{% trans "Ago" %}', '{% trans "Set" %}', '{% trans "Out" %}',
                '{% trans "Nov" %}', '{% trans "Dez" %}'];

            var fmodel_text = [];

            var msg = '{% trans "Terá de preencher o(s) campo(s) da opção selecionada para as condições de água." %}';
            var msg1 = '{% trans "Terá de preencher o(s) campo(s) da opção selecionada para as condições de água." %}';
            var msg2 = '{% trans "Para continuar terá de corrigir os campos inválidos." %}';

            const checkboxes = document.querySelectorAll('input[name="ftypename"]:checked');

            console.log(checkboxes);

            //console.log(checkboxes.parentElement.innerHTML);

            {% if "fecal" in wq_type %}
                if(flag){
                    var vals_ecoli = [];
                    var ecoli_input = $("input[name='ecoli_input']:checked").val();
                    if (ecoli_input == 'annual') {
                        var field = $('#id_ecoli13');
                        if (field.val() == '' || !field[0].validity.valid) {
                            flag = false;
                            field.focus();
                            activateTab("ecoli");
                            msg = msg1;
                            if (!field[0].validity.valid) msg = msg2;
                        } else {
                            vals_ecoli.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                        }
                    }
                    else if (ecoli_input == 'monthly') {
                        for (var index = 1; index < 13; ++index) {
                            var field = $('#id_ecoli' + index);
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("ecoli");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                                break;
                            }
                            vals_ecoli.push(months[index-1] + ':' + field.val().replace(',', '.'));
                        }
                        vals_ecoli = "[" + vals_ecoli.join(", ") + "]";
                    }
                    else if (ecoli_input == 'url') {
                        var field = $('#id_url');
                        if (field.val().indexOf("http://") == -1) {
                            msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                            flag = false;
                        } else {
                            vals_ecoli.push(field.val());
                        }
                    }
                    fmodel_text.push("{% trans "E-coli" %}: " + vals_ecoli.toString());
                    if(flag){
                        var vals_enterococcus = [];
                        var enterococcus_input = $("input[name='enterococcus_input']:checked").val();

                        if (enterococcus_input == 'annual') {
                            // Annual option was selected
                            var field = $('#id_enterococcus13');
                            // Check if value exists and is valid
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("enterococcus");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_enterococcus.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        }
                        else if (enterococcus_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_enterococcus' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    activateTab("enterococcus");
                                    msg = msg1;
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_enterococcus.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_enterococcus = "[" + vals_enterococcus.join(", ") + "]";
                        }
                        else if (enterococcus_input == 'url') {
                        var field = $('#id_url');
                        if (field.val().indexOf("http://") == -1) {
                            msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                            flag = false;
                        } else {
                            vals_enterococcus.push(field.val());
                        }
                    }
                        fmodel_text.push("{% trans "Enterococcus" %}: " + vals_enterococcus.toString());
                    }
                }

            {% endif %}

            {% if "generic" in wq_type %}

                if(flag){
                    var vals_generic = [];
                    var generic_input = $("input[name='generic_input']:checked").val();
                    if (generic_input == 'annual') {
                        var field = $('#id_generic13');
                        if (field.val() == '' || !field[0].validity.valid) {
                            flag = false;
                            field.focus();
                            activateTab("generic");
                            msg = msg1;
                            if (!field[0].validity.valid) msg = msg2;
                        } else {
                            vals_generic.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                        }
                    }
                    else if (generic_input == 'monthly') {
                        for (var index = 1; index < 13; ++index) {
                            var field = $('#id_generic' + index);
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                activateTab("generic");
                                msg = msg1;
                                if (!field[0].validity.valid) msg = msg2;
                                break;
                            }
                            vals_generic.push(months[index-1] + ':' + field.val().replace(',', '.'));
                        }
                        vals_generic = "[" + vals_generic.join(", ") + "]";
                    }
                    else if (generic_input == 'url') {
                        var field = $('#id_url');
                        if (field.val().indexOf("http://") == -1) {
                            msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                            flag = false;
                        } else {
                            vals_generic.push(field.val());
                        }
                    }
                    fmodel_text.push("{% trans "Traçador Genérico" %}: " + vals_generic.toString());
                }

            {% endif %}

            if (!flag) {
                $('#form_errors').html(msg);
                $("#form_errors").show();
            } else {
                // Update table client-side
                var bids = $('#bidLabel').html().split(',');
                for (var i = 0; i < bids.length; ++i) {
                    var sel_bid = bids[i];
                    console.log(sel_bid);
                    var bidrow = $("#forcings_table td.bid:contains('" + sel_bid + "')").parent();
                    if (bidrow) {
                        var bid = bidrow[0].cells[1].innerText;
                        if (sel_bid == bid) {
                            console.log(fmodel_text);
                            bidrow[0].cells[3].innerHTML = prettify(fmodel_text);
                        }
                    }
                }

                // Remove highlight from selected layers
                for (var i = 0; i < bids.length; ++i) {
                    var layer = boundariesLayer.getLayer(bids[i]);
                    if (layer) boundariesLayer.resetStyle(layer);
                }
                // Unselect all checkboxes in table
                $('.selBID:checked').prop("checked", false);
                // Close modal form
                $('#divModal_forcing').modal('hide');
            }
        });

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true, errors = [], error_str = '';
            var msg = '{% trans "Para continuar terá de:" %}' + '<br/>';

            try {
                // Validate boundary typology and water forcings
                var forcings = [];
                var water_forcings = [];
                $('#forcings_table tbody tr').each(function(i, obj){
                    var bid = obj.cells[1].innerText;
                    var ftype = get_fType(obj.cells[2].innerText);
                    var fmodel = obj.cells[3].innerText;

                    if(fmodel == ''){
                        flagok = false;

                        {% if "fecal" in wq_type %}
                            flagok = false;
                            error_str = '{% trans "- selecionar forçamentos de E-coli e Enterococcus a aplicar a todas as fronteiras na tabela." %}';
                            
                        {% endif %}

                        {% if "generic" in wq_type %}
                            flagok = false;
                            error_str = '{% trans "- selecionar forçamentos de Traçador Genérico a aplicar a todas as fronteiras oceânicas na tabela." %}';
                        {% endif %}
                        if (errors.indexOf(error_str) === -1) errors.push(error_str);
                    }

                    // DePrettify long JSON
                    fmodel = deprettify(fmodel, ftype);
                    forcings.push({'bid': bid, 'ftype': ftype, 'fmodel': fmodel});
                });

                w_source = findWaterSource($('.form').serialize().split("&"));

                if (w_source.length == 0){
                    flagok = false;
                    error_str = '{% trans "- selecionar fontes pontuais adicionais para a qualidade da água." %}';
                    if (errors.indexOf(error_str) === -1) errors.push(error_str);
                }

                if (!flagok) {
                    $('#msg_str').html(msg + errors.join('<br/>'));
                    $('#divModal_msg').modal('show');
                    return false;
                }

                $('#divModal_processing').modal('show');

                water_forcings.push({'ws_model': w_source});

                $.ajaxSetup({beforeSend: function(xhr, settings){
                    xhr.setRequestHeader('X-CSRFToken', '{{ csrf_token }}');
                }});

                $('#id_forcings').val(JSON.stringify(forcings));
                var btnname = e.currentTarget.name;
                if (btnname == 'edit') {
                    e.preventDefault();
                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: {
                            'getdata': JSON.stringify(forcings),
                            'getwaterdata': JSON.stringify(water_forcings)
                        },
                        dataType: 'json',
                        success: function(data) {
                            $('#divModal_processing').modal('hide');

                            if (data['msg']) {
                                $('#msg_str').html(data['msg']);
                                $('#divModal_msg').modal('show');
                            }

                            step7_check = true;
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });
                }
                else{
                    e.preventDefault();
                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: {
                            'getdata': JSON.stringify(forcings),
                            'getwaterdata': JSON.stringify(water_forcings)
                        },
                        dataType: 'json',
                        success: function(data) {
                            location.reload();
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });

                }
            } catch(err) {
                e.preventDefault();
                console.log(err);
                $('#divModal_processing').modal('hide');

                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });

        function findWaterSource(form_info){
            var ws_entry;
            var ws_model;

            for(var i = 0; i < form_info.length; i++){
                if(form_info[i].includes('wsmodel')){
                    ws_entry = form_info[i];
                }
            }
        
            ws_model = ws_entry.split('=')[1];

            return ws_model;
        }

        function get_fType(text) {
            var outvalue = '';
            
            if(text == 'Fluvial')
                outvalue = 'river';

            else if(text == 'Oceânica')
                outvalue = 'ocean';

            return outvalue;
        }

        // DePrettify long JSON
        function deprettify(string, type) {
            var out = {};
            var fmodeltype = "string";

            var arr = string.split('\n');
            for (var i = 0; i < arr.length; ++i) {
                if (arr[i].indexOf(':') > -1) {
                    // multiple objects
                    var obj = arr[i].split(":")[0];
                    var val = arr[i].substring(obj.length+1, arr[i].length); // Get the rest of the string
                } else {
                    // if single object then its flow
                    var obj = "flow";
                    var val = arr[i];
                }

                {% if "fecal" in wq_type or "generic" in wq_type %}
                    if (val.indexOf('[') >= 0) {
                        // Monthly
                        var sarray = val.replace("[", "").replace("]", "").split(', ');
                        var oarray = [];
                        for (var j=0; j<sarray.length; j++) {
                            oarray.push(parseFloat(sarray[j].split(":")[1]));
                        }
                        out[obj] = {'type': 'monthly', 'value': oarray};
                    }
                    else if (val.indexOf('=') >= 0) {
                        // Annual
                        out[obj] = {'type': 'annual', 'value': parseFloat(val.split("=")[1])};
                    }
                    else if (val.indexOf('http') >= 0) {
                        // Url
                        out[obj] = {'type': 'url', 'value': val};
                    }
                {% endif %}
            }

            console.log(out);
            return out;
        }

        // Prettify long JSON
        function prettify(json) {
            var out = "";
            for (var i = 0; i < json.length; ++i) {
                var obj = JSON.stringify(json[i], null, ' ');
                if (i == json.length - 1) {
                    out += obj.replace(/"/g, "").replace("{", "").replace("}", "");
                } else {
                    out += obj.replace(/"/g, "").replace("{", "").replace("}", "") + '<br>';
                }
            }
            return out;
        }

        function toggleDrop(){
            var value = $('#drop_sources :selected').text();
	        console.log(value);

            var url_sources_dad = document.getElementById("url_sources").parentElement;

            {% if not flag_continue %}
            if(value.includes("mapa") || value.includes("map"))
                document.getElementById("btn_submit").innerHTML = '{% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>';
            else
                document.getElementById("btn_submit").innerHTML = '{% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>';
            {% endif %}

            if(value.includes("URL"))
                url_sources_dad.style.visibility = "visible";
            else
                url_sources_dad.style.visibility = "hidden";
        }

        // Tooltips Setup (for Intro.js)
        $('#forcings_table td:first').parent().attr("data-step", 5);
        $('#forcings_table td:first').parent().attr("data-intro", "{% trans 'Selecione uma ou mais fronteiras da tabela' %}");

        $('#btn_define').attr("data-step", 6);
        $('#btn_define').attr("data-intro", "{% trans 'Prima o botão e defina as condições de água para as fronteiras a partir do formulário' %}");

        $('#forcings_table').parent().attr("data-step", 7);
        $('#forcings_table').parent().attr("data-intro", "{% trans 'Repita até definir as condições de água para todas as fronteiras' %}");

        $('#id_oceanmodel').attr("data-step", 8);
        $('#id_oceanmodel').attr("data-intro", "{% trans 'Selecione as condições de água a aplicar às fronteiras' %}");

        $('#id_atmmodel').attr("data-step", 9);
        $('#id_atmmodel').attr("data-intro", "{% trans 'Selecione um forçamento' %}");

        $(function(){    
            // Hide error panel
            $('#form_errors').hide();

            // Set Table as resizable
            $(".resizableCols .col1").resizable({
                handles: 'e',
                minWidth: 300,
                maxWidth: 600,
                resize: function() {
                    $('.col1').css('width', $('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth() + '%');
                    $('.col2').css('width', 100 - ($('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth()) + '%');
                    map.invalidateSize(false);
                }
            });

            // Add bootstrap behavior to 'ftype' radio inputs to work as tab controller
            $("input[name='ftype']").each(function() {
                console.log("olá");
                $(this).attr({'data-target': "#" + $(this).val()});
            });

            // On 'ftype' change work as tab controller
            $("input[name='ftype']").change(function() {
                $(this).tab('show');
                $(this).blur();

                $("#form_errors").hide();
                $('#form_errors').html('');
            });

            {% if "url" in ws_model %}
                var url_sources_dad = document.getElementById("url_sources").parentElement;
                url_sources_dad.style.visibility = "visible";
            {% else %}
                var url_sources_dad = document.getElementById("url_sources").parentElement;
                url_sources_dad.style.visibility = "hidden";
            {% endif %}

        });
        {% endif %}
        
    </script>

{% endblock content %}
